"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@babel/core");

var _s2sHelperGetPluginName = require("s2s-helper-get-plugin-name");

var _pluginSyntaxTypescript = _interopRequireDefault(require("@babel/plugin-syntax-typescript"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = (code, {
  eventPath,
  plugin,
  filename
}) => {
  if (!plugin || !plugin.plugin) {
    throw new Error('required plugin');
  }

  const options = plugin.plugin;
  const fromOptions = {
    from: eventPath
  };
  const lastPlugin = Array.isArray(options) ? [options[0], _objectSpread({}, options[1], fromOptions)] : [options, fromOptions];
  const {
    code: result
  } = (0, _core.transform)(code, {
    filename,
    babelrc: false,
    configFile: false,
    plugins: [_pluginSyntaxTypescript.default, lastPlugin]
  });
  return {
    code: result ? result.trim() : '',
    meta: {
      handlerName: 'typescript',
      pluginName: (0, _s2sHelperGetPluginName.getPluginName)(lastPlugin[0])
    }
  };
};

exports.default = _default;